/*
Copyright The KubeEdge Authors.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

// Code generated by client-gen. DO NOT EDIT.

package fake

import (
	"context"

	v1alpha1 "github.com/kubeedge/api/apis/apps/v1alpha1"
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	labels "k8s.io/apimachinery/pkg/labels"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	testing "k8s.io/client-go/testing"
)

// FakeEdgeApplications implements EdgeApplicationInterface
type FakeEdgeApplications struct {
	Fake *FakeAppsV1alpha1
	ns   string
}

var edgeapplicationsResource = v1alpha1.SchemeGroupVersion.WithResource("edgeapplications")

var edgeapplicationsKind = v1alpha1.SchemeGroupVersion.WithKind("EdgeApplication")

// Get takes name of the edgeApplication, and returns the corresponding edgeApplication object, and an error if there is any.
func (c *FakeEdgeApplications) Get(ctx context.Context, name string, options v1.GetOptions) (result *v1alpha1.EdgeApplication, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewGetAction(edgeapplicationsResource, c.ns, name), &v1alpha1.EdgeApplication{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.EdgeApplication), err
}

// List takes label and field selectors, and returns the list of EdgeApplications that match those selectors.
func (c *FakeEdgeApplications) List(ctx context.Context, opts v1.ListOptions) (result *v1alpha1.EdgeApplicationList, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewListAction(edgeapplicationsResource, edgeapplicationsKind, c.ns, opts), &v1alpha1.EdgeApplicationList{})

	if obj == nil {
		return nil, err
	}

	label, _, _ := testing.ExtractFromListOptions(opts)
	if label == nil {
		label = labels.Everything()
	}
	list := &v1alpha1.EdgeApplicationList{ListMeta: obj.(*v1alpha1.EdgeApplicationList).ListMeta}
	for _, item := range obj.(*v1alpha1.EdgeApplicationList).Items {
		if label.Matches(labels.Set(item.Labels)) {
			list.Items = append(list.Items, item)
		}
	}
	return list, err
}

// Watch returns a watch.Interface that watches the requested edgeApplications.
func (c *FakeEdgeApplications) Watch(ctx context.Context, opts v1.ListOptions) (watch.Interface, error) {
	return c.Fake.
		InvokesWatch(testing.NewWatchAction(edgeapplicationsResource, c.ns, opts))

}

// Create takes the representation of a edgeApplication and creates it.  Returns the server's representation of the edgeApplication, and an error, if there is any.
func (c *FakeEdgeApplications) Create(ctx context.Context, edgeApplication *v1alpha1.EdgeApplication, opts v1.CreateOptions) (result *v1alpha1.EdgeApplication, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewCreateAction(edgeapplicationsResource, c.ns, edgeApplication), &v1alpha1.EdgeApplication{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.EdgeApplication), err
}

// Update takes the representation of a edgeApplication and updates it. Returns the server's representation of the edgeApplication, and an error, if there is any.
func (c *FakeEdgeApplications) Update(ctx context.Context, edgeApplication *v1alpha1.EdgeApplication, opts v1.UpdateOptions) (result *v1alpha1.EdgeApplication, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewUpdateAction(edgeapplicationsResource, c.ns, edgeApplication), &v1alpha1.EdgeApplication{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.EdgeApplication), err
}

// UpdateStatus was generated because the type contains a Status member.
// Add a +genclient:noStatus comment above the type to avoid generating UpdateStatus().
func (c *FakeEdgeApplications) UpdateStatus(ctx context.Context, edgeApplication *v1alpha1.EdgeApplication, opts v1.UpdateOptions) (*v1alpha1.EdgeApplication, error) {
	obj, err := c.Fake.
		Invokes(testing.NewUpdateSubresourceAction(edgeapplicationsResource, "status", c.ns, edgeApplication), &v1alpha1.EdgeApplication{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.EdgeApplication), err
}

// Delete takes name of the edgeApplication and deletes it. Returns an error if one occurs.
func (c *FakeEdgeApplications) Delete(ctx context.Context, name string, opts v1.DeleteOptions) error {
	_, err := c.Fake.
		Invokes(testing.NewDeleteActionWithOptions(edgeapplicationsResource, c.ns, name, opts), &v1alpha1.EdgeApplication{})

	return err
}

// DeleteCollection deletes a collection of objects.
func (c *FakeEdgeApplications) DeleteCollection(ctx context.Context, opts v1.DeleteOptions, listOpts v1.ListOptions) error {
	action := testing.NewDeleteCollectionAction(edgeapplicationsResource, c.ns, listOpts)

	_, err := c.Fake.Invokes(action, &v1alpha1.EdgeApplicationList{})
	return err
}

// Patch applies the patch and returns the patched edgeApplication.
func (c *FakeEdgeApplications) Patch(ctx context.Context, name string, pt types.PatchType, data []byte, opts v1.PatchOptions, subresources ...string) (result *v1alpha1.EdgeApplication, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewPatchSubresourceAction(edgeapplicationsResource, c.ns, name, pt, data, subresources...), &v1alpha1.EdgeApplication{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.EdgeApplication), err
}
