/*
Copyright The KubeEdge Authors.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

// Code generated by client-gen. DO NOT EDIT.

package fake

import (
	"context"

	v1beta1 "github.com/kubeedge/api/apis/devices/v1beta1"
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	labels "k8s.io/apimachinery/pkg/labels"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	testing "k8s.io/client-go/testing"
)

// FakeDeviceModels implements DeviceModelInterface
type FakeDeviceModels struct {
	Fake *FakeDevicesV1beta1
	ns   string
}

var devicemodelsResource = v1beta1.SchemeGroupVersion.WithResource("devicemodels")

var devicemodelsKind = v1beta1.SchemeGroupVersion.WithKind("DeviceModel")

// Get takes name of the deviceModel, and returns the corresponding deviceModel object, and an error if there is any.
func (c *FakeDeviceModels) Get(ctx context.Context, name string, options v1.GetOptions) (result *v1beta1.DeviceModel, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewGetAction(devicemodelsResource, c.ns, name), &v1beta1.DeviceModel{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1beta1.DeviceModel), err
}

// List takes label and field selectors, and returns the list of DeviceModels that match those selectors.
func (c *FakeDeviceModels) List(ctx context.Context, opts v1.ListOptions) (result *v1beta1.DeviceModelList, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewListAction(devicemodelsResource, devicemodelsKind, c.ns, opts), &v1beta1.DeviceModelList{})

	if obj == nil {
		return nil, err
	}

	label, _, _ := testing.ExtractFromListOptions(opts)
	if label == nil {
		label = labels.Everything()
	}
	list := &v1beta1.DeviceModelList{ListMeta: obj.(*v1beta1.DeviceModelList).ListMeta}
	for _, item := range obj.(*v1beta1.DeviceModelList).Items {
		if label.Matches(labels.Set(item.Labels)) {
			list.Items = append(list.Items, item)
		}
	}
	return list, err
}

// Watch returns a watch.Interface that watches the requested deviceModels.
func (c *FakeDeviceModels) Watch(ctx context.Context, opts v1.ListOptions) (watch.Interface, error) {
	return c.Fake.
		InvokesWatch(testing.NewWatchAction(devicemodelsResource, c.ns, opts))

}

// Create takes the representation of a deviceModel and creates it.  Returns the server's representation of the deviceModel, and an error, if there is any.
func (c *FakeDeviceModels) Create(ctx context.Context, deviceModel *v1beta1.DeviceModel, opts v1.CreateOptions) (result *v1beta1.DeviceModel, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewCreateAction(devicemodelsResource, c.ns, deviceModel), &v1beta1.DeviceModel{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1beta1.DeviceModel), err
}

// Update takes the representation of a deviceModel and updates it. Returns the server's representation of the deviceModel, and an error, if there is any.
func (c *FakeDeviceModels) Update(ctx context.Context, deviceModel *v1beta1.DeviceModel, opts v1.UpdateOptions) (result *v1beta1.DeviceModel, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewUpdateAction(devicemodelsResource, c.ns, deviceModel), &v1beta1.DeviceModel{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1beta1.DeviceModel), err
}

// Delete takes name of the deviceModel and deletes it. Returns an error if one occurs.
func (c *FakeDeviceModels) Delete(ctx context.Context, name string, opts v1.DeleteOptions) error {
	_, err := c.Fake.
		Invokes(testing.NewDeleteActionWithOptions(devicemodelsResource, c.ns, name, opts), &v1beta1.DeviceModel{})

	return err
}

// DeleteCollection deletes a collection of objects.
func (c *FakeDeviceModels) DeleteCollection(ctx context.Context, opts v1.DeleteOptions, listOpts v1.ListOptions) error {
	action := testing.NewDeleteCollectionAction(devicemodelsResource, c.ns, listOpts)

	_, err := c.Fake.Invokes(action, &v1beta1.DeviceModelList{})
	return err
}

// Patch applies the patch and returns the patched deviceModel.
func (c *FakeDeviceModels) Patch(ctx context.Context, name string, pt types.PatchType, data []byte, opts v1.PatchOptions, subresources ...string) (result *v1beta1.DeviceModel, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewPatchSubresourceAction(devicemodelsResource, c.ns, name, pt, data, subresources...), &v1beta1.DeviceModel{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1beta1.DeviceModel), err
}
