/*
Copyright The KubeEdge Authors.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

// Code generated by client-gen. DO NOT EDIT.

package v1alpha1

import (
	"context"
	"time"

	v1alpha1 "github.com/kubeedge/api/apis/operations/v1alpha1"
	scheme "github.com/kubeedge/api/client/clientset/versioned/scheme"
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	rest "k8s.io/client-go/rest"
)

// NodeUpgradeJobsGetter has a method to return a NodeUpgradeJobInterface.
// A group's client should implement this interface.
type NodeUpgradeJobsGetter interface {
	NodeUpgradeJobs() NodeUpgradeJobInterface
}

// NodeUpgradeJobInterface has methods to work with NodeUpgradeJob resources.
type NodeUpgradeJobInterface interface {
	Create(ctx context.Context, nodeUpgradeJob *v1alpha1.NodeUpgradeJob, opts v1.CreateOptions) (*v1alpha1.NodeUpgradeJob, error)
	Update(ctx context.Context, nodeUpgradeJob *v1alpha1.NodeUpgradeJob, opts v1.UpdateOptions) (*v1alpha1.NodeUpgradeJob, error)
	UpdateStatus(ctx context.Context, nodeUpgradeJob *v1alpha1.NodeUpgradeJob, opts v1.UpdateOptions) (*v1alpha1.NodeUpgradeJob, error)
	Delete(ctx context.Context, name string, opts v1.DeleteOptions) error
	DeleteCollection(ctx context.Context, opts v1.DeleteOptions, listOpts v1.ListOptions) error
	Get(ctx context.Context, name string, opts v1.GetOptions) (*v1alpha1.NodeUpgradeJob, error)
	List(ctx context.Context, opts v1.ListOptions) (*v1alpha1.NodeUpgradeJobList, error)
	Watch(ctx context.Context, opts v1.ListOptions) (watch.Interface, error)
	Patch(ctx context.Context, name string, pt types.PatchType, data []byte, opts v1.PatchOptions, subresources ...string) (result *v1alpha1.NodeUpgradeJob, err error)
	NodeUpgradeJobExpansion
}

// nodeUpgradeJobs implements NodeUpgradeJobInterface
type nodeUpgradeJobs struct {
	client rest.Interface
}

// newNodeUpgradeJobs returns a NodeUpgradeJobs
func newNodeUpgradeJobs(c *OperationsV1alpha1Client) *nodeUpgradeJobs {
	return &nodeUpgradeJobs{
		client: c.RESTClient(),
	}
}

// Get takes name of the nodeUpgradeJob, and returns the corresponding nodeUpgradeJob object, and an error if there is any.
func (c *nodeUpgradeJobs) Get(ctx context.Context, name string, options v1.GetOptions) (result *v1alpha1.NodeUpgradeJob, err error) {
	result = &v1alpha1.NodeUpgradeJob{}
	err = c.client.Get().
		Resource("nodeupgradejobs").
		Name(name).
		VersionedParams(&options, scheme.ParameterCodec).
		Do(ctx).
		Into(result)
	return
}

// List takes label and field selectors, and returns the list of NodeUpgradeJobs that match those selectors.
func (c *nodeUpgradeJobs) List(ctx context.Context, opts v1.ListOptions) (result *v1alpha1.NodeUpgradeJobList, err error) {
	var timeout time.Duration
	if opts.TimeoutSeconds != nil {
		timeout = time.Duration(*opts.TimeoutSeconds) * time.Second
	}
	result = &v1alpha1.NodeUpgradeJobList{}
	err = c.client.Get().
		Resource("nodeupgradejobs").
		VersionedParams(&opts, scheme.ParameterCodec).
		Timeout(timeout).
		Do(ctx).
		Into(result)
	return
}

// Watch returns a watch.Interface that watches the requested nodeUpgradeJobs.
func (c *nodeUpgradeJobs) Watch(ctx context.Context, opts v1.ListOptions) (watch.Interface, error) {
	var timeout time.Duration
	if opts.TimeoutSeconds != nil {
		timeout = time.Duration(*opts.TimeoutSeconds) * time.Second
	}
	opts.Watch = true
	return c.client.Get().
		Resource("nodeupgradejobs").
		VersionedParams(&opts, scheme.ParameterCodec).
		Timeout(timeout).
		Watch(ctx)
}

// Create takes the representation of a nodeUpgradeJob and creates it.  Returns the server's representation of the nodeUpgradeJob, and an error, if there is any.
func (c *nodeUpgradeJobs) Create(ctx context.Context, nodeUpgradeJob *v1alpha1.NodeUpgradeJob, opts v1.CreateOptions) (result *v1alpha1.NodeUpgradeJob, err error) {
	result = &v1alpha1.NodeUpgradeJob{}
	err = c.client.Post().
		Resource("nodeupgradejobs").
		VersionedParams(&opts, scheme.ParameterCodec).
		Body(nodeUpgradeJob).
		Do(ctx).
		Into(result)
	return
}

// Update takes the representation of a nodeUpgradeJob and updates it. Returns the server's representation of the nodeUpgradeJob, and an error, if there is any.
func (c *nodeUpgradeJobs) Update(ctx context.Context, nodeUpgradeJob *v1alpha1.NodeUpgradeJob, opts v1.UpdateOptions) (result *v1alpha1.NodeUpgradeJob, err error) {
	result = &v1alpha1.NodeUpgradeJob{}
	err = c.client.Put().
		Resource("nodeupgradejobs").
		Name(nodeUpgradeJob.Name).
		VersionedParams(&opts, scheme.ParameterCodec).
		Body(nodeUpgradeJob).
		Do(ctx).
		Into(result)
	return
}

// UpdateStatus was generated because the type contains a Status member.
// Add a +genclient:noStatus comment above the type to avoid generating UpdateStatus().
func (c *nodeUpgradeJobs) UpdateStatus(ctx context.Context, nodeUpgradeJob *v1alpha1.NodeUpgradeJob, opts v1.UpdateOptions) (result *v1alpha1.NodeUpgradeJob, err error) {
	result = &v1alpha1.NodeUpgradeJob{}
	err = c.client.Put().
		Resource("nodeupgradejobs").
		Name(nodeUpgradeJob.Name).
		SubResource("status").
		VersionedParams(&opts, scheme.ParameterCodec).
		Body(nodeUpgradeJob).
		Do(ctx).
		Into(result)
	return
}

// Delete takes name of the nodeUpgradeJob and deletes it. Returns an error if one occurs.
func (c *nodeUpgradeJobs) Delete(ctx context.Context, name string, opts v1.DeleteOptions) error {
	return c.client.Delete().
		Resource("nodeupgradejobs").
		Name(name).
		Body(&opts).
		Do(ctx).
		Error()
}

// DeleteCollection deletes a collection of objects.
func (c *nodeUpgradeJobs) DeleteCollection(ctx context.Context, opts v1.DeleteOptions, listOpts v1.ListOptions) error {
	var timeout time.Duration
	if listOpts.TimeoutSeconds != nil {
		timeout = time.Duration(*listOpts.TimeoutSeconds) * time.Second
	}
	return c.client.Delete().
		Resource("nodeupgradejobs").
		VersionedParams(&listOpts, scheme.ParameterCodec).
		Timeout(timeout).
		Body(&opts).
		Do(ctx).
		Error()
}

// Patch applies the patch and returns the patched nodeUpgradeJob.
func (c *nodeUpgradeJobs) Patch(ctx context.Context, name string, pt types.PatchType, data []byte, opts v1.PatchOptions, subresources ...string) (result *v1alpha1.NodeUpgradeJob, err error) {
	result = &v1alpha1.NodeUpgradeJob{}
	err = c.client.Patch(pt).
		Resource("nodeupgradejobs").
		Name(name).
		SubResource(subresources...).
		VersionedParams(&opts, scheme.ParameterCodec).
		Body(data).
		Do(ctx).
		Into(result)
	return
}
