/*
Copyright The KubeEdge Authors.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

// Code generated by client-gen. DO NOT EDIT.

package fake

import (
	"context"

	v1alpha1 "github.com/kubeedge/api/apis/reliablesyncs/v1alpha1"
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	labels "k8s.io/apimachinery/pkg/labels"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	testing "k8s.io/client-go/testing"
)

// FakeClusterObjectSyncs implements ClusterObjectSyncInterface
type FakeClusterObjectSyncs struct {
	Fake *FakeReliablesyncsV1alpha1
}

var clusterobjectsyncsResource = v1alpha1.SchemeGroupVersion.WithResource("clusterobjectsyncs")

var clusterobjectsyncsKind = v1alpha1.SchemeGroupVersion.WithKind("ClusterObjectSync")

// Get takes name of the clusterObjectSync, and returns the corresponding clusterObjectSync object, and an error if there is any.
func (c *FakeClusterObjectSyncs) Get(ctx context.Context, name string, options v1.GetOptions) (result *v1alpha1.ClusterObjectSync, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootGetAction(clusterobjectsyncsResource, name), &v1alpha1.ClusterObjectSync{})
	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.ClusterObjectSync), err
}

// List takes label and field selectors, and returns the list of ClusterObjectSyncs that match those selectors.
func (c *FakeClusterObjectSyncs) List(ctx context.Context, opts v1.ListOptions) (result *v1alpha1.ClusterObjectSyncList, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootListAction(clusterobjectsyncsResource, clusterobjectsyncsKind, opts), &v1alpha1.ClusterObjectSyncList{})
	if obj == nil {
		return nil, err
	}

	label, _, _ := testing.ExtractFromListOptions(opts)
	if label == nil {
		label = labels.Everything()
	}
	list := &v1alpha1.ClusterObjectSyncList{ListMeta: obj.(*v1alpha1.ClusterObjectSyncList).ListMeta}
	for _, item := range obj.(*v1alpha1.ClusterObjectSyncList).Items {
		if label.Matches(labels.Set(item.Labels)) {
			list.Items = append(list.Items, item)
		}
	}
	return list, err
}

// Watch returns a watch.Interface that watches the requested clusterObjectSyncs.
func (c *FakeClusterObjectSyncs) Watch(ctx context.Context, opts v1.ListOptions) (watch.Interface, error) {
	return c.Fake.
		InvokesWatch(testing.NewRootWatchAction(clusterobjectsyncsResource, opts))
}

// Create takes the representation of a clusterObjectSync and creates it.  Returns the server's representation of the clusterObjectSync, and an error, if there is any.
func (c *FakeClusterObjectSyncs) Create(ctx context.Context, clusterObjectSync *v1alpha1.ClusterObjectSync, opts v1.CreateOptions) (result *v1alpha1.ClusterObjectSync, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootCreateAction(clusterobjectsyncsResource, clusterObjectSync), &v1alpha1.ClusterObjectSync{})
	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.ClusterObjectSync), err
}

// Update takes the representation of a clusterObjectSync and updates it. Returns the server's representation of the clusterObjectSync, and an error, if there is any.
func (c *FakeClusterObjectSyncs) Update(ctx context.Context, clusterObjectSync *v1alpha1.ClusterObjectSync, opts v1.UpdateOptions) (result *v1alpha1.ClusterObjectSync, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootUpdateAction(clusterobjectsyncsResource, clusterObjectSync), &v1alpha1.ClusterObjectSync{})
	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.ClusterObjectSync), err
}

// UpdateStatus was generated because the type contains a Status member.
// Add a +genclient:noStatus comment above the type to avoid generating UpdateStatus().
func (c *FakeClusterObjectSyncs) UpdateStatus(ctx context.Context, clusterObjectSync *v1alpha1.ClusterObjectSync, opts v1.UpdateOptions) (*v1alpha1.ClusterObjectSync, error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootUpdateSubresourceAction(clusterobjectsyncsResource, "status", clusterObjectSync), &v1alpha1.ClusterObjectSync{})
	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.ClusterObjectSync), err
}

// Delete takes name of the clusterObjectSync and deletes it. Returns an error if one occurs.
func (c *FakeClusterObjectSyncs) Delete(ctx context.Context, name string, opts v1.DeleteOptions) error {
	_, err := c.Fake.
		Invokes(testing.NewRootDeleteActionWithOptions(clusterobjectsyncsResource, name, opts), &v1alpha1.ClusterObjectSync{})
	return err
}

// DeleteCollection deletes a collection of objects.
func (c *FakeClusterObjectSyncs) DeleteCollection(ctx context.Context, opts v1.DeleteOptions, listOpts v1.ListOptions) error {
	action := testing.NewRootDeleteCollectionAction(clusterobjectsyncsResource, listOpts)

	_, err := c.Fake.Invokes(action, &v1alpha1.ClusterObjectSyncList{})
	return err
}

// Patch applies the patch and returns the patched clusterObjectSync.
func (c *FakeClusterObjectSyncs) Patch(ctx context.Context, name string, pt types.PatchType, data []byte, opts v1.PatchOptions, subresources ...string) (result *v1alpha1.ClusterObjectSync, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootPatchSubresourceAction(clusterobjectsyncsResource, name, pt, data, subresources...), &v1alpha1.ClusterObjectSync{})
	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.ClusterObjectSync), err
}
