/*
Copyright The KubeEdge Authors.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

// Code generated by informer-gen. DO NOT EDIT.

package v1alpha1

import (
	"context"
	time "time"

	operationsv1alpha1 "github.com/kubeedge/api/apis/operations/v1alpha1"
	versioned "github.com/kubeedge/api/client/clientset/versioned"
	internalinterfaces "github.com/kubeedge/api/client/informers/externalversions/internalinterfaces"
	v1alpha1 "github.com/kubeedge/api/client/listers/operations/v1alpha1"
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	runtime "k8s.io/apimachinery/pkg/runtime"
	watch "k8s.io/apimachinery/pkg/watch"
	cache "k8s.io/client-go/tools/cache"
)

// NodeUpgradeJobInformer provides access to a shared informer and lister for
// NodeUpgradeJobs.
type NodeUpgradeJobInformer interface {
	Informer() cache.SharedIndexInformer
	Lister() v1alpha1.NodeUpgradeJobLister
}

type nodeUpgradeJobInformer struct {
	factory          internalinterfaces.SharedInformerFactory
	tweakListOptions internalinterfaces.TweakListOptionsFunc
}

// NewNodeUpgradeJobInformer constructs a new informer for NodeUpgradeJob type.
// Always prefer using an informer factory to get a shared informer instead of getting an independent
// one. This reduces memory footprint and number of connections to the server.
func NewNodeUpgradeJobInformer(client versioned.Interface, resyncPeriod time.Duration, indexers cache.Indexers) cache.SharedIndexInformer {
	return NewFilteredNodeUpgradeJobInformer(client, resyncPeriod, indexers, nil)
}

// NewFilteredNodeUpgradeJobInformer constructs a new informer for NodeUpgradeJob type.
// Always prefer using an informer factory to get a shared informer instead of getting an independent
// one. This reduces memory footprint and number of connections to the server.
func NewFilteredNodeUpgradeJobInformer(client versioned.Interface, resyncPeriod time.Duration, indexers cache.Indexers, tweakListOptions internalinterfaces.TweakListOptionsFunc) cache.SharedIndexInformer {
	return cache.NewSharedIndexInformer(
		&cache.ListWatch{
			ListFunc: func(options v1.ListOptions) (runtime.Object, error) {
				if tweakListOptions != nil {
					tweakListOptions(&options)
				}
				return client.OperationsV1alpha1().NodeUpgradeJobs().List(context.TODO(), options)
			},
			WatchFunc: func(options v1.ListOptions) (watch.Interface, error) {
				if tweakListOptions != nil {
					tweakListOptions(&options)
				}
				return client.OperationsV1alpha1().NodeUpgradeJobs().Watch(context.TODO(), options)
			},
		},
		&operationsv1alpha1.NodeUpgradeJob{},
		resyncPeriod,
		indexers,
	)
}

func (f *nodeUpgradeJobInformer) defaultInformer(client versioned.Interface, resyncPeriod time.Duration) cache.SharedIndexInformer {
	return NewFilteredNodeUpgradeJobInformer(client, resyncPeriod, cache.Indexers{cache.NamespaceIndex: cache.MetaNamespaceIndexFunc}, f.tweakListOptions)
}

func (f *nodeUpgradeJobInformer) Informer() cache.SharedIndexInformer {
	return f.factory.InformerFor(&operationsv1alpha1.NodeUpgradeJob{}, f.defaultInformer)
}

func (f *nodeUpgradeJobInformer) Lister() v1alpha1.NodeUpgradeJobLister {
	return v1alpha1.NewNodeUpgradeJobLister(f.Informer().GetIndexer())
}
