/*
Copyright The KubeEdge Authors.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

// Code generated by lister-gen. DO NOT EDIT.

package v1alpha1

import (
	v1alpha1 "github.com/kubeedge/api/apis/apps/v1alpha1"
	"k8s.io/apimachinery/pkg/api/errors"
	"k8s.io/apimachinery/pkg/labels"
	"k8s.io/client-go/tools/cache"
)

// NodeGroupLister helps list NodeGroups.
// All objects returned here must be treated as read-only.
type NodeGroupLister interface {
	// List lists all NodeGroups in the indexer.
	// Objects returned here must be treated as read-only.
	List(selector labels.Selector) (ret []*v1alpha1.NodeGroup, err error)
	// Get retrieves the NodeGroup from the index for a given name.
	// Objects returned here must be treated as read-only.
	Get(name string) (*v1alpha1.NodeGroup, error)
	NodeGroupListerExpansion
}

// nodeGroupLister implements the NodeGroupLister interface.
type nodeGroupLister struct {
	indexer cache.Indexer
}

// NewNodeGroupLister returns a new NodeGroupLister.
func NewNodeGroupLister(indexer cache.Indexer) NodeGroupLister {
	return &nodeGroupLister{indexer: indexer}
}

// List lists all NodeGroups in the indexer.
func (s *nodeGroupLister) List(selector labels.Selector) (ret []*v1alpha1.NodeGroup, err error) {
	err = cache.ListAll(s.indexer, selector, func(m interface{}) {
		ret = append(ret, m.(*v1alpha1.NodeGroup))
	})
	return ret, err
}

// Get retrieves the NodeGroup from the index for a given name.
func (s *nodeGroupLister) Get(name string) (*v1alpha1.NodeGroup, error) {
	obj, exists, err := s.indexer.GetByKey(name)
	if err != nil {
		return nil, err
	}
	if !exists {
		return nil, errors.NewNotFound(v1alpha1.Resource("nodegroup"), name)
	}
	return obj.(*v1alpha1.NodeGroup), nil
}
