/*
Copyright The KubeEdge Authors.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

// Code generated by lister-gen. DO NOT EDIT.

package v1alpha1

import (
	v1alpha1 "github.com/kubeedge/api/apis/policy/v1alpha1"
	"k8s.io/apimachinery/pkg/api/errors"
	"k8s.io/apimachinery/pkg/labels"
	"k8s.io/client-go/tools/cache"
)

// ServiceAccountAccessLister helps list ServiceAccountAccesses.
// All objects returned here must be treated as read-only.
type ServiceAccountAccessLister interface {
	// List lists all ServiceAccountAccesses in the indexer.
	// Objects returned here must be treated as read-only.
	List(selector labels.Selector) (ret []*v1alpha1.ServiceAccountAccess, err error)
	// ServiceAccountAccesses returns an object that can list and get ServiceAccountAccesses.
	ServiceAccountAccesses(namespace string) ServiceAccountAccessNamespaceLister
	ServiceAccountAccessListerExpansion
}

// serviceAccountAccessLister implements the ServiceAccountAccessLister interface.
type serviceAccountAccessLister struct {
	indexer cache.Indexer
}

// NewServiceAccountAccessLister returns a new ServiceAccountAccessLister.
func NewServiceAccountAccessLister(indexer cache.Indexer) ServiceAccountAccessLister {
	return &serviceAccountAccessLister{indexer: indexer}
}

// List lists all ServiceAccountAccesses in the indexer.
func (s *serviceAccountAccessLister) List(selector labels.Selector) (ret []*v1alpha1.ServiceAccountAccess, err error) {
	err = cache.ListAll(s.indexer, selector, func(m interface{}) {
		ret = append(ret, m.(*v1alpha1.ServiceAccountAccess))
	})
	return ret, err
}

// ServiceAccountAccesses returns an object that can list and get ServiceAccountAccesses.
func (s *serviceAccountAccessLister) ServiceAccountAccesses(namespace string) ServiceAccountAccessNamespaceLister {
	return serviceAccountAccessNamespaceLister{indexer: s.indexer, namespace: namespace}
}

// ServiceAccountAccessNamespaceLister helps list and get ServiceAccountAccesses.
// All objects returned here must be treated as read-only.
type ServiceAccountAccessNamespaceLister interface {
	// List lists all ServiceAccountAccesses in the indexer for a given namespace.
	// Objects returned here must be treated as read-only.
	List(selector labels.Selector) (ret []*v1alpha1.ServiceAccountAccess, err error)
	// Get retrieves the ServiceAccountAccess from the indexer for a given namespace and name.
	// Objects returned here must be treated as read-only.
	Get(name string) (*v1alpha1.ServiceAccountAccess, error)
	ServiceAccountAccessNamespaceListerExpansion
}

// serviceAccountAccessNamespaceLister implements the ServiceAccountAccessNamespaceLister
// interface.
type serviceAccountAccessNamespaceLister struct {
	indexer   cache.Indexer
	namespace string
}

// List lists all ServiceAccountAccesses in the indexer for a given namespace.
func (s serviceAccountAccessNamespaceLister) List(selector labels.Selector) (ret []*v1alpha1.ServiceAccountAccess, err error) {
	err = cache.ListAllByNamespace(s.indexer, s.namespace, selector, func(m interface{}) {
		ret = append(ret, m.(*v1alpha1.ServiceAccountAccess))
	})
	return ret, err
}

// Get retrieves the ServiceAccountAccess from the indexer for a given namespace and name.
func (s serviceAccountAccessNamespaceLister) Get(name string) (*v1alpha1.ServiceAccountAccess, error) {
	obj, exists, err := s.indexer.GetByKey(s.namespace + "/" + name)
	if err != nil {
		return nil, err
	}
	if !exists {
		return nil, errors.NewNotFound(v1alpha1.Resource("serviceaccountaccess"), name)
	}
	return obj.(*v1alpha1.ServiceAccountAccess), nil
}
